<script>
  // Dimensions
  const width = 800;
  const height = 100;
  const margin = { top: 20, right: 5, bottom: 5, left: 5 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Array
  const values = [
    { x: 2, y: 1, category: "cat1" },
    { x: 4, y: 2, category: "cat3" },
    { x: 6, y: 1, category: "cat2" },
    { x: 7, y: 3, category: "cat3" },
    { x: 9, y: 1, category: "cat2" }
  ];
  import {scaleLinear} from 'd3-scale';
  import {scaleOrdinal} from 'd3-scale';
  import {schemeDark2}from 'd3-scale-chromatic';
  import {extent} from 'd3-array';
  const classcolour = extent(values, (d) => d.category);
  const scaleValues_x=scaleLinear()
  .domain([1,10])
  .range([0,innerWidth]);
  const scaleValues_y=scaleLinear()
  .domain([0,3])
  .range([innerHeight,0]);
  const ordinal=scaleOrdinal()
  .range(schemeDark2)
  .domain(classcolour);
</script>

<svg viewBox="0 0 {width} {height}">
  <g transform="translate({margin.left},{margin.top})">
    <!--  -->
    <rect x="0" y={scaleValues_y(0)} width="800" height="1" />
    {#each values as value}
     <circle r=5 cy={scaleValues_y(+value.y)} cx={scaleValues_x(+value.x)} style="fill: {ordinal(value.category)};"/>
     <text class="valueLabel" x={scaleValues_x(+value.x)} y={scaleValues_y(+value.y)-10}>{value.y} </text> 
     <rect x={scaleValues_x(+value.x)-0.5} y={scaleValues_y(+value.y)+5} width="1" height={innerHeight-scaleValues_y(+value.y)-5} />
    {/each}
  </g>
</svg>

<style>
  text {
    text-anchor: middle;
    font-size: small;
  }
</style>
